---
title: DOMHighResTimeStamp
slug: Web/API/DOMHighResTimeStamp
tags:
  - API
  - DOMHighResTimeStamp
  - High Resolution Time
  - Milliseconds
  - Performance
  - Reference
  - Time
  - Type
  - speed
  - timeStamp
---
<p>{{APIRef("High Resolution Time")}}</p>

<p><span class="seoSummary">The <code><strong>DOMHighResTimeStamp</strong></code> type is a <code>double</code> and is used to store a time value in milliseconds.</span> This type can be used to describe a discrete point in time or a time interval (the difference in time between two discrete points in time).</p>

<p>The time, given in milliseconds, should be accurate to 5 µs (microseconds), with the fractional part of the number indicating fractions of a millisecond. However, if the browser is unable to provide a time value accurate to 5 µs (due, for example, to hardware or software constraints), the browser can represent the value as a time in milliseconds accurate to a millisecond. Also note the section below on reduced time precision controlled by browser preferences to avoid timing attacks and fingerprinting.</p>

<p>Further, if the device or operating system the user agent is running on doesn't have a clock accurate to the microsecond level, they may only be accurate to the millisecond.</p>

<h2 id="Reduced_time_precision">Reduced time precision</h2>

<p>To offer protection against timing attacks and fingerprinting, the precision of time stamps might get rounded depending on browser settings. In Firefox, the <code>privacy.reduceTimerPrecision</code>  preference is enabled by default and defaults to 20 µs in Firefox 59; in 60 it will be 2ms.</p>

<pre class="brush: js notranslate">// reduced time precision (2ms) in Firefox 60
event.timeStamp
// 1519211809934
// 1519211810362
// 1519211811670
// ...

// reduced time precision with `privacy.resistFingerprinting` enabled
event.timeStamp;
// 1519129853500
// 1519129858900
// 1519129864400
// ...
</pre>

<p>In Firefox, you can also enable <code>privacy.resistFingerprinting</code>, the precision will be 100ms or the value of <code>privacy.resistFingerprinting.reduceTimerPrecision.microseconds</code>, whichever is larger.</p>

<h2 id="Properties">Properties</h2>

<p><em>This <em>type</em> has no properties. It is a double-precision floating-point value.</em></p>

<h3 id="Value">Value</h3>

<p>The value of a <code>DOMHighResTimeStamp</code> is a double-precision floating-point number which describes the number of milliseconds (accurate to within 5 microseconds if the device supports it) elapsed between two points in time. The starting time can be either a specific time determined by the script for a site or app, or the <strong>time origin</strong>.</p>

<h4 id="The_time_origin">The time origin</h4>

<p>The <strong>time origin</strong> is a standard time which is considered to be the beginning of the current document's lifetime. It's calculated like this:</p>

<ul>
 <li>If the script's {{Glossary("global object")}} is a {{domxref("Window")}}, the time origin is determined as follows:
  <ul>
   <li>If the current {{domxref("Document")}} is the first one loaded in the <code>Window</code>, the time origin is the time at which the browser context was created.</li>
   <li>If during the process of unloading the previous document which was loaded in the window, a confirmation dialog was displayed to let the user confirm whether or not to leave the previous page, the time origin is the time at which the user confirmed that navigating to the new page was acceptable.</li>
   <li>If neither of the above determines the time origin, then the time origin is the time at which the navigation responsible for creating the window's current <code>Document</code> took place.</li>
  </ul>
 </li>
 <li>If the script's global object is a {{domxref("WorkerGlobalScope")}} (that is, the script is running as a web worker), the time origin is the moment at which the worker was created.</li>
 <li>In all other cases, the time origin is undefined.</li>
</ul>

<h2 id="Methods">Methods</h2>

<p><em>This <em>type</em> has no methods.</em></p>

<h2 id="Usage_notes">Usage notes</h2>

<p>You can get the current timestamp value—the time that has elapsed since the context was created—by calling the {{domxref("performance")}} method {{domxref("performance.now", "now()")}}. This method is available in both {{domxref("Window")}} and {{domxref("Worker")}} contexts.</p>

<h2 id="Example">Example</h2>

<p>To determine how much time has elapsed since a particular point in your code, you can do something like this:</p>

<pre class="brush: js notranslate">let startTime = performance.now();

/* ... do things for a while ... */

let elapsedTime = performance.now() - startTime;
</pre>

<p>Upon completion, the value of <code>elapsedTime</code> is the number of milliseconds that have elapsed since you recorded the starting time in line 1.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('Highres Time Level 2', '#dom-domhighrestimestamp', 'DOMHighResTimeStamp')}}</td>
   <td>{{Spec2('Highres Time Level 2')}}</td>
   <td>Stricter definitions of interfaces and types.</td>
  </tr>
  <tr>
   <td>{{SpecName('Highres Time', '#sec-DOMHighResTimeStamp', 'DOMHighResTimeStamp')}}</td>
   <td>{{Spec2('Highres Time')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.DOMHighResTimestamp")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Navigation_timing">Navigation Timing API</a></li>
 <li>{{domxref("Performance")}}</li>
 <li><code><a href="/en-US/docs/Web/API/Performance/now">performance.now()</a></code></li>
</ul>
